<?php
namespace Teknisa\CTB\Modules\Saldos\Controllers;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\CTB\Modules\Saldos\Services\RecalculoSaldosService;

class RecalculoSaldosController {
    
    protected $recalculoSaldoService;
    
    public function __construct(RecalculoSaldosService $recalculoSaldoService) {
        $this->recalculoSaldoService = $recalculoSaldoService;
    }
    
    public function validatePeriodoContabil(Row $request, Response $response) {
        try{
            $row = $request->getRow();
            $this->recalculoSaldoService->validateRow($row);
            $this->recalculoSaldoService->validatePeriodoContabil($row);
        }
        catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
		
	}
	
	public function recalcularSaldo(Row $request, Response $response){
	    try{
	        $row = $request->getRow();
            $this->recalculoSaldoService->validateRow($row);
            $this->recalculoSaldoService->validatePeriodoContabil($row);
            $this->recalculoSaldoService->recalcularSaldo($row);
	    }
	    catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
	}
}